#!/bin/sh
#
# stage_1.sh - FreeBSD From Scratch,  1 ʳ: ƥΥ󥹥ȡ
#              Ȥ: ./stage_1.sh profile
#              ɤ߹ե: ./stage_1.conf.profile
#              񤭽Фե: ./stage_1.log.profile
#
# :      Jens Schweikhardt
# $Id: stage_1.sh,v 1.1.1.1.2.2 2006/03/13 15:03:02 rushani Exp $
# $FreeBSD: doc/ja_JP.eucJP/articles/fbsd-from-scratch/stage_1.sh,v 1.2 2006/03/13 16:46:15 rushani Exp $
# Original revision: 1.5

PATH=/bin:/usr/bin:/sbin:/usr/sbin

# ȤĶ:
#
# a) "make buildworld"  "make buildkernel" ˽λƤ뤳ȡ
# b) ̤ѥѡƥ󤬤뤳 (롼ȥե륷ƥѤ˾ʤȤ 1 ġ
#    ߤ˱ /usr  /var ѤΤΤѰդ)
# c) ޥ줿 stage_1.conf.profile ե롣

if test $# -ne 1; then
  echo "usage: stage_1.sh profile" 1>&2
  exit 1
fi

# ---------------------------------------------------------------------------- #
# ƥå 1: $DESTDIR ʲ˶Υǥ쥯ȥĥ꡼
# ---------------------------------------------------------------------------- #

step_one () {
  create_file_systems

  # ¾Τ٤ƤΥǥ쥯ȥɬܡ
  cd ${SRC}/etc; make distrib-dirs DESTDIR=${DESTDIR}
}

# ---------------------------------------------------------------------------- #
# ƥå 2: /etc ǥ쥯ȥĥ꡼ / ˥եɲ
# ---------------------------------------------------------------------------- #

step_two () {
  copy_files

  # mergemaster κȥե뤬к
  TEMPROOT=/var/tmp/temproot.stage1
  if test -d ${TEMPROOT}; then
    chflags -R 0 ${TEMPROOT}
    rm -rf ${TEMPROOT}
  fi
  export MAKEDEVPATH="/bin:/sbin:/usr/bin"
  mergemaster -i -m ${SRC}/etc -t ${TEMPROOT} -D ${DESTDIR}
  cap_mkdb ${DESTDIR}/etc/login.conf
  pwd_mkdb -d ${DESTDIR}/etc -p ${DESTDIR}/etc/master.passwd

  # mergemaster  /var/log ֤եʤΤǡ
  # Ǻ copy_files ǥԡƤϡȤ
  cd ${TEMPROOT}
  find . -type f | sed 's,^\./,,' |
  while read f; do
    if test -r ${DESTDIR}/${f}; then
      echo "${DESTDIR}/${f} already exists; not copied"
    else
      echo "Creating empty ${DESTDIR}/${f}"
      cp -p ${f} ${DESTDIR}/${f}
    fi
  done
  chflags -R 0 ${TEMPROOT}
  rm -rf ${TEMPROOT}
}

# ---------------------------------------------------------------------------- #
# ƥå 3: installworld ¹Ԥ
# ---------------------------------------------------------------------------- #

step_three () {
  cd ${SRC}
  make installworld DESTDIR=${DESTDIR}

  # ɲäθߴ饤֥򥤥󥹥ȡ뤹 (ץ)libc.so.4 
  # ưŪ󥯤ץबСĤޤꡢ
  # /usr/libexec/ld-elf.so.1: Shared object "libc.so.4" not found
  # Ȥ顼åĤä顢Ѥ뤳ȡ
  cd lib/compat/compat4x.i386
  make all install DESTDIR=${DESTDIR}
}

# ---------------------------------------------------------------------------- #
# ƥå 4: ͥȥ⥸塼򥤥󥹥ȡ뤹
# ---------------------------------------------------------------------------- #

step_four () {
  cd ${SRC}
  # installkernel åȤˤϡloader.conf  device.hints ɬס 
  # ƥå 2 ǥԡƤʤС 2 ԤȤäƥԡ뤳ȡ
  #   cp sys/boot/forth/loader.conf ${DESTDIR}/boot/defaults
  #   cp sys/i386/conf/GENERIC.hints ${DESTDIR}/boot/device.hints
  make installkernel DESTDIR=${DESTDIR} KERNCONF=${KERNCONF}
}

# ---------------------------------------------------------------------------- #
# ƥå 5: /etc/fstab ȥॾΥ󥹥ȡ
# ---------------------------------------------------------------------------- #

step_five () {
  create_etc_fstab

  # ॾꡣۤȤɤξɬܡ
  cp ${DESTDIR}/usr/share/zoneinfo/${TIMEZONE} ${DESTDIR}/etc/localtime
  if test -r /etc/wall_cmos_clock; then
    cp -p /etc/wall_cmos_clock ${DESTDIR}/etc/wall_cmos_clock
  fi
}

# ---------------------------------------------------------------------------- #
# ƥå 6: ĤΥޥ
# ---------------------------------------------------------------------------- #

step_six () {
  all_remaining_customization
}

do_steps () {
  echo "PROFILE=${PROFILE}"
  echo "DESTDIR=${DESTDIR}"
  echo "SRC=${SRC}"
  echo "KERNCONF=${KERNCONF}"
  echo "TIMEZONE=${TIMEZONE}"
  echo "TYPE=${TYPE}"
  echo "REVISION=${REVISION}"
  echo "BRANCH=${BRANCH}"
  echo "RELDATE=${RELDATE}"
  step_one
  step_two
  step_three
  step_four
  step_five
  step_six
}

# ---------------------------------------------------------------------------- #
# ¹Գ
# ---------------------------------------------------------------------------- #

PROFILE="$1"
set -x -e -u # 顼ȯ뤫̤ѿѤߤ롣
. ./stage_1.conf.${PROFILE}

# world  make Τ˻Ȥ줿ɤѿ򤤤Ĥꤹ롣
# ѿϡȤ 4.x  5.x ɤΥƥ򥤥󥹥ȡ뤹
# ȤäưѹΤ˻Ȥ롣RELDATE Ф
# __FreeBSD_version  Port ԤΤΥϥɥ֥å (Porter's Handbook)
# Ƥ롣
# doc/en_US.ISO8859-1/books/porters-handbook/freebsd-versions.html
# ܸǤ⤢뤬ǿξϱѸǤ򻲾ȤΤȡ
# doc/ja_JP.eucJP/books/porters-handbook/freebsd-versions.html
# ϡ<᥸㡼ֹ><ޥʡֹ 2 ><꡼֥ʤ 0, ʳ 1>xx
# ̤ϼΤ褦ʤΤˤʤ롣
#
#   TYPE="FreeBSD"
#   REVISION="4.9"
#   BRANCH="RC"      { "CURRENT", "STABLE", "RELEASE" }
#   RELDATE="502101"
#
eval $(awk '/^(TYPE|REVISION|BRANCH)=/' ${SRC}/sys/conf/newvers.sh)
RELDATE=$(awk '/^[ \t]*#[ \t]*define[ \t][ \t]*__FreeBSD_version[ \t]/ {
                print $3
              }' ${SRC}/sys/sys/param.h)

echo "=> Logging to stage_1.log.${PROFILE}"
do_steps 2>&1 | tee stage_1.log.${PROFILE}

# vim: tabstop=2:expandtab:shiftwidth=2:
# EOF $RCSfile: stage_1.sh,v $
